#include "prefs.h"

#include <exec/types.h>
#include <exec/memory.h>
#include <dos/dos.h>
#include <dos/dosextens.h>
#include <intuition/intuition.h>
#include <libraries/reqtools.h>

#ifdef LATTICE
#include <proto/exec.h>
#include <proto/dos.h>
#include <proto/reqtools.h>
#endif


struct ReqToolsBase *ReqToolsBase = NULL;


Prototype void OpenReqToolsLib(void);
Prototype void CloseReqToolsLib(void);
Prototype BOOL IsReqToolsOpen(void);
Prototype BOOL GetRTString(char *,long,char *);
Prototype BOOL GetRTFRQ(char *,char *,char *);
Prototype void AboutElmWindow(void);
Prototype void RTPalette(void);



void OpenReqToolsLib(void)
{
  ReqToolsBase=(struct ReqToolsBase *)OpenLibrary("reqtools.library",37L);
}



void CloseReqToolsLib(void)
{
  if (ReqToolsBase)
    CloseLibrary((struct Library *)ReqToolsBase);
    ReqToolsBase = NULL;
}



BOOL IsReqToolsOpen(void)
{
  return(ReqToolsBase!=NULL);
}



BOOL GetRTString(char *str,long len,char *title)
{
  if (ReqToolsBase) {
    if (rtGetString(str,len,title,NULL,RT_WaitPointer,TRUE,TAG_END))
      return(TRUE);
    else
      rtEZRequestTags("You entered nothing :-(","I'm sorry",
                      NULL,NULL,RT_WaitPointer,TRUE,TAG_END);
  }
  return(FALSE);
}



BOOL GetRTFRQ(char *dir,char *file,char *res)
{
  struct rtFileRequester *filereq;
  BPTR oldlock,newlock;
  char filename[109];

  if (ReqToolsBase) {
    if (strlen(dir)>0) {
      if (newlock=Lock(dir,SHARED_LOCK))
        oldlock = CurrentDir(newlock);
    }

    if (filereq = rtAllocRequestA(RT_FILEREQ,NULL)) {
      strcpy(filename,file);
      if (rtFileRequest(filereq,filename,"Pick a file",RT_WaitPointer,TRUE,TAG_END)) {
/*
        rtEZRequest("You picked the file:\n'%s'\nin directory:\n'%s'",
                     "Right", NULL, NULL, filename, filereq->Dir);
*/
        strcpy(res,filereq->Dir);
        if (strlen(res)>0) {
          switch(res[strlen(res)-1]) {
          case ':': break;
          case '/': break;
          default:
            strcat(res,"/");
            break;
          }
        }
        strcat(res,filename);
        if (strlen(dir)>0) {
          if (newlock) {
            newlock = CurrentDir(oldlock);
            UnLock(newlock);
          }
        }
        return(TRUE);
      }
      else
         rtEZRequest("You didn't pick a file.", "No", NULL, NULL);

      rtFreeRequest (filereq);
    }

    if (strlen(dir)>0) {
      if (newlock) {
        newlock = CurrentDir(oldlock);
        UnLock(newlock);
      }
    }
  }
  return(FALSE);
}



void AboutElmWindow(void)
{
  struct TagItem rttags[5];
  rttags[0].ti_Tag  = RTEZ_ReqTitle;
  rttags[0].ti_Data = (ULONG)"About";
  rttags[1].ti_Tag  = RT_WaitPointer;
  rttags[1].ti_Data = TRUE;
  rttags[2].ti_Tag  = RT_ReqPos;
  rttags[2].ti_Data = REQPOS_CENTERWIN;
  rttags[3].ti_Tag  = RTEZ_Flags;
  rttags[3].ti_Data = EZREQF_CENTERTEXT;
  rttags[4].ti_Tag  = TAG_END;
  rttags[4].ti_Data = NULL;
  if (ReqToolsBase) {
    rtEZRequest("\n-->   Amiga Elm %s   <--\n\n"
		"\nAndreas M. Kirchwitz\n"
		"(amk@zikzak.in-berlin.de)\n"
		"Seesener Str. 69\nW-1000 Berlin 31\n"
		"Federal Republic of Germany\n",
		"Continue...",NULL,rttags,VERSION);
  }
}



void RTPalette(void)
{
  if (ReqToolsBase)
    rtPaletteRequest("Change palette",NULL,RT_WaitPointer,TRUE,TAG_END);
}
